<div fxFlex fxLayout="row" class="container">
  <h1 class="kd-header">Reports</h1>
  <mat-divider></mat-divider>
  <div class="kd-div-top-spacer"></div>

  <div class="form-group">
    <mat-form-field class="kd-date">
      <input matInput [matDatepicker]="picker" [(ngModel)]="datePicker" placeholder="Select date">
      <mat-datepicker-toggle matSuffix [for]="picker"></mat-datepicker-toggle>
      <mat-datepicker #picker></mat-datepicker>
    </mat-form-field>
  </div>

  <div class="form-group">
    <h4 class="kd-report-title">Report text</h4>
    <textarea rows="12" cols="55" [(ngModel)]="reportText" class="kd-report-text"></textarea>
  </div>
  <div class="kd-div-top-spacer"></div>

  <button [ngClass]="hoverClass()"
          (click)="onCreateReport()"
          [disabled]="!hasReportText()">
    <div class="kd-inline">
      <mat-icon>post_add</mat-icon>
      <span class="kd-inline-text">Create report</span>
    </div>
  </button>
  <div style="padding-top: 50px;"></div>

  <h1 class="kd-header">History</h1>
  <mat-divider></mat-divider>
  <div class="kd-div-top-spacer"></div>

  <div *ngIf="showReports(); else noReports">
    <mat-grid-list cols="4" gutterSize="5px" rowHeight="220px">
      <mat-grid-tile *ngFor="let report of getOwnReports()" class="kd-grid-tile">
        <app-report-preview [report]="report"
                            (reportChanges)="onReportChanges($event)">
        </app-report-preview>
      </mat-grid-tile>
    </mat-grid-list>
  </div>
  <ng-template #noReports>
    <h3>No reports ...</h3>
  </ng-template>

  <div class="kd-div-top-spacer"></div>
  <div style="padding-top: 50px;"></div>

  <div class="kd-inline">
    <mat-icon>library_books</mat-icon>
    <span class="kd-inline-text kd-hover" (click)="onShowArchive()">
      {{ showArchiveText }}
    </span>
  </div>
  <div style="padding-top: 30px;"></div>

  <div *ngIf="this.authService.isLoggedOwner(); else userArchive">
    <div *ngIf="showArchive">
      <div *ngIf="showArchivedReports(); else emptyArchive">
        <mat-grid-list cols="4" gutterSize="5px" rowHeight="220px">
          <mat-grid-tile *ngFor="let report of archivedReports" class="kd-grid-tile">
            <app-report-preview [report]="report"
                                [inArchive]="true"
                                [displayUser]="true"
                                (reportChanges)="onReportChanges($event)">
            </app-report-preview>
          </mat-grid-tile>
        </mat-grid-list>
        <div class="kd-div-top-spacer"></div>

        <button class="btn kd-clear-archive" (click)="onClearArchive()">
          <div class="kd-inline">
            <mat-icon>delete_forever</mat-icon>
            <span class="kd-inline-text">Clear archive</span>
          </div>
        </button>
        <div class="kd-div-top-spacer"></div>
        <div style="padding-top: 30px;"></div>
      </div>

      <ng-template #emptyArchive>
        Archive is empty
      </ng-template>
    </div>
  </div>

  <ng-template #userArchive>
    <div *ngIf="showArchive">
      <div *ngIf="showArchivedReportsForUser(); else emptyArchiveForUser">
        <mat-grid-list cols="4" gutterSize="5px" rowHeight="220px">
          <mat-grid-tile *ngFor="let report of archivedReportsForUser" class="kd-grid-tile">
            <app-report-preview [report]="report"
                                [inArchive]="true"
                                [isUserArchive]="true"
                                (reportChanges)="onReportChanges($event)">
            </app-report-preview>
          </mat-grid-tile>
        </mat-grid-list>
      </div>

      <ng-template #emptyArchiveForUser>
        Archive is empty
      </ng-template>
    </div>
  </ng-template>

  <div class="kd-div-top-spacer"></div>
  <div style="padding-top: 50px;"></div>

  <div *ngIf="authService.isLoggedOwner()">
    <h1 class="kd-header">Employee reports history</h1>
    <mat-divider></mat-divider>
    <div class="kd-div-top-spacer"></div>

    <div *ngIf="showUserReports(); else noUserReports">
      <div *ngFor="let userReports of allUsersReports">
        <div *ngIf="userHasReports(userReports); else userHasNoReports">
          <h4 class="kd-header">{{ userReports.user.firstname }} {{ userReports.user.lastname }}</h4>
          <div style="padding-top: 10px;"></div>

          <mat-grid-list cols="4" gutterSize="5px" rowHeight="220px">
            <mat-grid-tile *ngFor="let report of userReports.reports" class="kd-grid-tile">
              <app-report-preview [report]="report"
                                  (reportChanges)="onReportChanges($event)">
              </app-report-preview>
            </mat-grid-tile>
          </mat-grid-list>
        </div>

        <ng-template #userHasNoReports>
          No reports for this employee
        </ng-template>
        <div class="kd-div-top-spacer"></div>
        <div style="padding-top: 30px;"></div>
      </div>
    </div>
    <ng-template #noUserReports>
      No employee reports
    </ng-template>
  </div>

</div>
